﻿using AutoWorkshopContracts.BindingModels;
using AutoWorkshopContracts.ViewModels;
using AutoWorkshopDataModels.Models;

namespace AutoWorkshopListImplement.Models
{
    public class Repair : IRepairModel
    {
        public int Id { get; private set; }
        
        public string RepairName { get; private set; } = string.Empty;
        
        public double Price { get; private set; }
        
        public Dictionary<int, (IComponentModel, int)> RepairComponents
        {
            get;
            private set;
        } = new Dictionary<int, (IComponentModel, int)>();
        
        public static Repair? Create(RepairBindingModel? Model)
        {
            if (Model is null)
                return null;
            
            return new Repair()
            {
                Id = Model.Id,
                RepairName = Model.RepairName,
                Price = Model.Price,
                RepairComponents = Model.RepairComponents
            };
        }
        
        public void Update(RepairBindingModel? Model)
        {
            if (Model is null)
                return;

            RepairName = Model.RepairName;
            Price = Model.Price;
            RepairComponents = Model.RepairComponents;
        }
        
        public RepairViewModel GetViewModel => new()
        {
            Id = Id,
            RepairName = RepairName,
            Price = Price,
            RepairComponents = RepairComponents
        };
    }
}
